<?php

use Drupal\node\Entity\Node;

function allinone_backup($type, &$context) {

  // Do heavy coding here...
  $message = 'Ready for create backup...';

  switch ($type) {
    case 'fullbackup':
      try {
      $new_folder = 'public://allinonefiles/';
      if (!is_dir(drupal_realpath($new_folder))) {
         file_prepare_directory($new_folder, FILE_CREATE_DIRECTORY);
      }
      //make sure the script has enough time to run (300 seconds  = 5 minutes)
      ini_set('max_execution_time', '300');
      ini_set('set_time_limit', '0');
      $targetname = 'fullbackup'.date("Y-m-d-his").'.zip';
      $target = drupal_realpath($new_folder).'/fullbackup'.date("Y-m-d-his").'.zip'; //default to archive.tar
      
      $dir = './.'; //defaults to all in current dir
    
      $exclude = '/^(?!(.*allinonefiles))(.*)$/i'; 
      //setup phar
      $phar = new PharData($target);
      //print_r($phar);
      $options = $phar->buildFromDirectory($dir,$exclude);
      //$phar->compress(Phar::GZ);
      //unlink($target);
      // Change Permission to all user access.
      chmod(drupal_realpath('public://allinonefiles'), 0777);
      chmod((drupal_realpath('public://allinonefiles/') . "/" . $target), 0755);
      $message = 'Compressing all files done, check your server for the file ' .$target;
      // Add Content For Database Backup History Display.
      $node = Node::create([
        'type' => 'allinone_backup',
        'title' => $targetname,
        'field_message_log' => $_SESSION['formlog'],
        'field_backup_type' => 'Files',
      ]);
      $node->save();
      $context['message'] = $message; 
      $context['results'] = $results;
    } catch (Exception $e) {
      // handle errors
      $message = 'An error has occured, details:'.$e->getMessage();
    }
      break;
    default:
      $message = "Could not create full backup zip try again";
      $context['message'] = $message; 
      $context['results'] = $results;
      break;
  }
}

function allinone_backup_finished_callback($success, $results, $operations) {
  // The 'success' parameter means no fatal PHP errors were detected. All
  // other error management should be handled using 'results'.
  if ($success) {
    $message = t('FullBackup successfully');
  }
  else {
    $message = t('Could not create full backup zip try again');
  }
  drupal_set_message($message);
}